# CREATIVE DATA MINING - FS 2016 
# Heatmaps of sensor data
# Prepared by Danielle Griego

# Import all datafiles in the specific file 
setwd("~/Dropbox/Data_parser/Test_3/Data_Matrices/") 
data = list.files(pattern="*.csv")
for (i in 1:length(data)) array <-assign(data[i], read.csv(data[i],header=F,skip=1))

# Install all packages
doInstall<- TRUE
toInstall<- c("fields", "spam", "grid")
if(doInstall){install.packages(toInstall, repos="http://cran.us.r-project.org")} #Make sure to be connected to the internet
lapply(toInstall, library, character.only = TRUE)

# Genergating basic HeatMaps as image.plot, image.plots used as example in Leceture 2
# Sound is used as an example, and can be used for all other parameters 
columns<- sound.csv[,2]
sound<-(sound.csv[,3:669])
sound<-data.matrix(sound)

HM1=image.plot(matrix((data=sound), ncol=25, nrow=667), horizontal=FALSE) #data matrix as x-axis is participant, y-axis is path
HM2=image.plot(matrix((data=sound), ncol=667, nrow=25), axes=FALSE, horizontal=TRUE) #data matrix as x-axis is path, y-axis is participant
help(image.plot) #Use this to customize plots

## 2 Additional packages/methods for additional heatmpas
# Reference: http://is-r.tumblr.com/post/32387034930/simplest-possible-heatmap-with-ggplot2

# Install necessary packages
doInstall <- TRUE 
toInstall <- c("ggplot2", "reshape2", "RColorBrewer")
if(doInstall){install.packages(toInstall, repos = "http://cran.us.r-project.org")}
lapply(toInstall, library, character.only = TRUE)

nRow <- 25
nCol <- 667

rownames(sound) <- c(1:nRow)
colnames(sound) <- c(1:nCol)

for(ii in 2:ncol(sound)){  sound[, ii] <- sound[, ii-1] + rnorm(nrow(sound))  }
for(ii in 2:nrow(sound)){  sound[ii, ] <- sound[ii-1, ] + rnorm(ncol(sound))  }

longData <- melt(sound)
head(longData, 20)

myPalette <- colorRampPalette(rev(brewer.pal(11, "Spectral")), space="Lab")

zp1 <- ggplot(longData,
              aes(x = Var2, y = Var1, fill = value))
zp1 <- zp1 + geom_tile()
zp1 <- zp1 + scale_fill_gradientn(colours = myPalette(100))
zp1 <- zp1 + scale_x_discrete(expand = c(0, 0))
zp1 <- zp1 + scale_y_discrete(expand = c(0, 0))
zp1 <- zp1 + coord_equal()
zp1 <- zp1 + theme_bw()
print(zp1)

